#ifndef __RAYTOMOOP_H_INCL__
#define __RAYTOMOOP_H_INCL__

/**
 * 
 * 
 * @author   yang
 */
#include "decl_fwd.h"
#include "op.h"

using boost::shared_ptr;

namespace Yang {

class RayTomoOp: public op {
public:
  RayTomoOp(const shared_ptr<AcqPar>& acqPars, const shared_ptr<rayTracer>& ray_tracer): acqPar_(acqPars), rayTracer_(ray_tracer) {}
  virtual void oper(cubeData<float>& mod, cubeData<float>& dat, bool bAdj, bool bAdd) {}
  virtual ~RayTomoOp() {}
  
  void traceOrginPtInfoIs(const vector<fwk::degree>& vAng, const float* coords, bool bUpward, const fwk::degree* dip = NULL);
  void acqCoverageMaskForCurSubsurfPt(vector<float>& mask, const vector<fwk::degree>& vADCIGang);
  
protected:
  shared_ptr<AcqPar> acqPar_;
  shared_ptr<rayTracer> rayTracer_;
  std::vector<stdVecFloat> rays_; std::vector<fwk::degree> vInciAngle_; //the stored ray paths and its corresponding incident angles, meansure with respect to the dip direction
};

} //end namespace
#endif // __RAYTOMOOP_H_INCL__

