#ifndef __CG_SOLV_H_INCL__
#define __CG_SOLV_H_INCL__

//Conjugate 
/**
 * TODO: Add class description
 * 
 * @author   zyang03
 */

#include "nsp_dc.h"

namespace sf_yang {
class cg_solv {
public:
  // Constructor
  cg_solv();

  // Destructor
  virtual ~cg_solv();

  // Copy constructor
  // TODO: Uncomment the copy constructor when you need it.
  //cg_solv(const cg_solv& src);

  // Assignment operator
  // TODO: Uncomment the assignment operator when you need it.
  //cg_solv& operator=(const cg_solv& src);

  int solve(float* mod, const float* mod0, const float* dat, Yang::op& L, 
            vector<float>& err, int maxIter=20, float fTol=1e-6, bool bReport=true);

  //this case operator L is a symmetric posi-defi matrix.
  int solveSym(float* mod, const float* mod0, const float* dat, Yang::op& L, float* eps,
            vector<float>& err, int maxIter=20, float fTol=1e-6, bool bReport=true);

  //Preconditioned version
  int solveSym_prec(float* mod, const float* mod0, const float* dat, Yang::op& L, Yang::op& S, float* eps,
            vector<float>& err, int maxIter=20, float fTol=1e-6, bool bReport=true);
  int solveSym_precmix(float* mod, const float* mod0, const float* dat, Yang::op& L, Yang::op& S, 
                    float* eps,vector<float>& err, int niterPrec, int maxIter, float fTol, bool bReport);
public:
};

// Constructor implementation
inline cg_solv::cg_solv()
{
}

// Destructor implementation
inline cg_solv::~cg_solv()
{
}

}

// TODO: Uncomment the copy constructor when you need it.
//inline cg_solv::cg_solv(const cg_solv& src)
//{
//   // TODO: copy
//}

// TODO: Uncomment the assignment operator when you need it.
//inline cg_solv& cg_solv::operator=(const cg_solv& rhs)
//{
//   if (this == &rhs) {
//      return *this;
//   }
//
//   // TODO: assignment
//
//   return *this;
//}

#endif // __CG_SOLV_H_INCL__
