#include "stdafx.h"
#include "cubeData.hpp"

#include "objFunc.h"
#include "commonOps.h"
using namespace Yang;
using namespace std;

//Simple objective function, use it to test correctness of the linear search schem
using namespace Yang;
using namespace std;


float simpleObjFunc::evaluate(const gVecComponent& model) {
  FUNC_TRACE_BEG(simpleObjFunc::evaluate);
  //store residue
  m_res.alloc(m_opMultiply->getDatShape());
  //calculat the fwd and take sum squares.
  gVecComponent& ncModel = const_cast<gVecComponent&>(model);
  m_opMultiply->oper(ncModel,m_res,false,false);
  m_res.subtract(m_dat);
  float ret = dotProd(m_res,m_res);
  FUNC_TRACE_END(ret);
}


void  simpleObjFunc::calcSearchDir( gVecComponent &searchDir) {
  FUNC_TRACE_BEG(FWI_objFunc::calcSearchDir);
  //calculate negative gradient(which is the search dir) this time, the gradient is just F'd.
  
  m_opMultiply->oper(searchDir,m_res,true,false);
  PRVEC(m_res.pval,m_res.size());
  PRVEC(searchDir.pval,searchDir.size());
  searchDir.scale(-1.0f);
  FUNC_TRACE_END();
}

cubeData<float>& simpleObjFunc::getCalcData() {
   return m_res;
}

