#ifndef __ALGO_H_INCL__
#define __ALGO_H_INCL__

namespace Yang{

// Find the   /(n-k)th largest/ : /kth smallest/    value in an array
//quantile finder.    median = quantile( size(a)/2, a)
template<class T> 
T quantile(int k, const T* ar, size_t n) {
    //k equals to the position in array
    T value;      // output value of quantile
    int j,jj;
    T ak;
    ak = ar[k-1];
    
    size_t ind;

    VERIFYC(k>0); VERIFYC(k<=n);
    
    std::vector<T> ar_pack,ar_pack2;
    ar_pack.reserve(n); ar_pack2.reserve(n);
    
    j=0,jj=0;
    for (ind=0; ind < n; ind++) {
      // How many a(:) < ak
      if (ar[ind]<ak) {
        j++;
        ar_pack.push_back(ar[ind]); //a<ak
      }
      // How many a(:) > ak
      if (ar[ind]>ak) {
        jj++;
        ar_pack2.push_back(ar[ind]);//a>ak
      }
    }
    
    if( j >= k) { //there are at least k elements smaller than ak
      value = quantile(k, &ar_pack[0],j);
    } else { //find out how many elements are bigger than ak
      j = k - n + jj;
      if( j > 0) {
        value = quantile(j, &ar_pack2[0],jj);
      } else {
        value = ak;
      }
    }
    return value;
  } //end function quantile

} //end namespace Yang

#endif // __ALGO_H_INCL__

