#ifndef AXIS_H
#define AXIS_H 1
#include<iostream>
#include<string>


class axis{
  public:
    virtual ~axis(){}
    axis(){}  //Default constructor does nothing
    //default operator should do the right thing
    axis(int n, float o, float d, std::string label, std::string unit);
    axis(int n, float o, float d, std::string label);
    axis(int n, float o, float d);
    axis(int n);
    
    void set(int n, float o, float d, string label);
    void set(int n, float o, float d, string label, string unit);
    void set(int n, float o, float d);
    void set(int n);

    //assignment operator, default should work too.
    //axis& operator = (const axis& ax_) {
    //  this->basic_set(ax_.n,ax_.o,ax_.d,ax_.label,ax_.unit);
    //  return *this;
    //}
    
    void print_info(const string& sz) const {
      prt("AXIS %s, %d %f %f, label=%s, unit=%s \n",sz.c_str(),n,o,d,
          label.c_str(),unit.c_str());
     }
    
    bool same_axis(const axis& ax) const;
    void get_nod(int &in, float &io, float& id) const {
      in = n;
      io = o; id = d;
    }
public:
    int n;
    float o,d;
    std::string label,unit;
public:
  
    void scaleUnit(float fScale) {
      this->o = this->o * fScale;
      this->d = this->d * fScale; return;
    }
   
    inline float get_coord( int offset) const {
      assert(offset>=0 && offset<n);
      return (d*(offset)+o); 
    }
    inline int get_offset( float coord) const {
      int ret=lroundf((coord-o)/d);
      assert(ret>=0 && ret<n);
      return ret;
    }
    inline float get_offsetf( float coord) const {  //get fractional offset
      return (coord-o)/d;
    }
    inline void getRange(float* pMin, float* pMax) const {
      assert(this->d>0.0f);
      if (pMin) {
        *pMin = this->o;
      }
      if (pMax) {
        *pMax = this->o + (n-1)*d;
      }
    }   
   //Alter the length of axis, but not changing axis.d
   //For example truncation or elongation
    axis alter(int offsetBeg, int offsetEnd = -1) {
      axis ax = *this;
      ax.o = this->get_coord(offsetBeg);
      if (offsetEnd==-1) {
        ax.n = this->n - offsetBeg;
      } else {
        ax.n = offsetEnd - offsetBeg + 1;
      }
      return ax;
    }
  
    //return a truncated axis based on the input range beg->end.
    axis return_truncated(float beg, float end) const;
    //given a smaller ax, return it location on my own axis
    void return_alignedoffset(const axis& ax, int& offset_, int &n_) const;
   
  private:
    void basic_set(int n, float o, float d, std::string label, std::string unit);
    
}; //end class axis

//Find the overlap of two axis.
void alignAxis(float& o1beg, int& n1,float& d1, const axis& ax1, const axis& ax2);
typedef std::vector<axis> vecAxis;
  
    
#endif

