#ifndef cd_step_H
#define cd_step_H
#include <valarray>

namespace Yang {
  class cdstepper {
    public:
      cdstepper(int nx, int ny);
      
      virtual int step(     
          bool forget     /* restart flag */, 
          int nx, int ny  /* model size, data size */, 
          float* x        /* current model [nx] */, 
          const float* g  /* gradient [nx] */, 
          float* rr       /* data residual [ny] */, 
          const float* gg /* conjugate gradient [ny] */
      );

//Step of conjugate-gradient iteration
    private:
      int m_nx,m_ny;
      std::valarray<float> S,ss;  /* Save the last step of model and residual */
      bool m_bAllocated; /* if S and Ss are allocated */
};

}

#endif

