#ifndef CUBEPTR_H
#define CUBEPTR_H

namespace Yang

{
class cubePtr
{
protected:
   long long calcOffset( stdvecInt & ns, stdvecInt & fw) //calculate offset based on the frame location (fw) and the size on each dimension
   {
      int ndim = ns.size();
      assert(ndim == int(fw.size()));
      long long offset = 0;
      
      assert(ndim >= 1);
      offset = fw[ndim-1];      
      for (int i=ndim-2; i >=0 ; i--)
      {
         offset *= ns[i];
         offset += fw[i];
      }
      return offset;
   }

   bool checkBound(stdvecInt &ns,stdvecInt& fw,stdvecInt& nw) //check the window defined by fw and nw is within the boundary of the hypercube
   {
      int ndim = ns.size();
      assert(ndim == int(fw.size()));
      int ndim_win = nw.size();
      assert(ndim_win <= ndim);
      
      bool bWithinBound = true;

      int n;
      int idim;
      for (idim=0; idim< ndim_win; idim++)
      {
         n=ns[idim];
         if(fw[idim]<0 || fw[idim]>=n || fw[idim]+nw[idim] > n)
         {
            bWithinBound = false;
            break;
         }
      }

      for (idim=ndim_win; idim < ndim; idim++)
      {
         n=ns[idim];
         if(fw[idim]<0 || fw[idim]>=n )
         {
            bWithinBound = false;
            break;
         }
      }
      return bWithinBound;
   }
};

} //end of namespace

#endif
