#include "stdafx.h"
#include "dampingFunc.h"

using namespace Yang;
using namespace std;

//the formula cos(0,pi/2) 
void cosDampingFunc::getCoef(stdVecFloat& coefVec, int length, float extent)
{
   int fullLength = int(length/extent+0.5);
   
   //calc the coef based on full length
   coefVec.resize(length);
   float frac;
   for(int i=0; i<length; i++)
   {
	  frac = float(i+1)/float(fullLength);
	  coefVec[i] = cos(frac*PI/2);
   }
}

//the cos(0,pi/2) 
void lineDampingFunc::getCoef(stdVecFloat& coefVec, int length, float extent)
{
   int fullLength = int(length/extent+0.5);
   
   //calc the coef based on full length
   coefVec.resize(length);
   float frac;
   for(int i=0; i<length; i++)
   {
	  frac = float(i+1)/float(fullLength);
	  coefVec[i] = 1 - frac;
   }
}

