#ifndef _DAMPINGFUNC_H_
#define _DAMPINGFUNC_H_

namespace Yang {
//damping func, exponential/cosine/hamming window all kinds of smooth decreasing function
class dampingFunc {
public:
   //extent=1.0, means damping to 0(full window length). otherwise damping ends at a fraction of the 
   //full window length
   void getCoefEx(stdVecFloat& coefVec,int length,float extent) {
	  if(!equalf(extent,0.0f)) {
		 this->getCoef(coefVec,length,extent);
	  }
	  //since extent=0.0 equals to disable the dampping. Set everything to 1.0
	  else {
		coefVec.assign(length,1.0f);
	  }
   }
   
protected:
   virtual void getCoef(stdVecFloat& coefVec, int length, float extent) = 0;
   
   virtual ~dampingFunc() {}
};

class cosDampingFunc: public dampingFunc {
public:
   virtual void getCoef(stdVecFloat& coefVec, int length, float extent);
};

class lineDampingFunc: public dampingFunc {
public:
   virtual void getCoef(stdVecFloat& coefVec, int length, float extent);
};

} //end namespace
#endif
