#ifndef DECL_FWD_H
#define DECL_FWD_H 1

//forward declaration
class axis;

class param_func;
class sep_params;

namespace Yang {
  //basics:
  class hypercube;
  template<class T>
  class cubeData;
  template<class T>
  class dmRsf_ocDump;
  
  //Some typedef for cubeData
  typedef cubeData<float> cubeDataF;
  typedef cubeData<double> cubeDataD;
  typedef cubeData<unsigned char> cubeDataB;
  typedef dmRsf_ocDump<float> ocDumpF;
  typedef dmRsf_ocDump<int>   ocDumpI;

  class AcqPar; //acquisiton parameters, like Geomoetry/sampling and other stuff
  class ImgPar;
  
  class FWI_FD;
  class WEMVA_FD;
  class velAnaParam;
  class waveOps;
  class FWI_Param;
  class waveOpParams;
  class OneWayParamTang;

  class WEMVA_Param;
  class dipEstimator;
  class RMO_Measurer; struct Param_RMO_Measurer;//measure the moveout information on the reconstructed angle gathers.
  class ADCIG_Recon; //ADCIG reconstructor.
  class cdstep;
  class op; class opChain20;
  class rayTracer;
  class RayTomoOp;
  class cdstepper;
  class RMOfinder;

  //for MPI program
  class branchFileName;
} //end namespace

namespace seplib{
  class AGC_Param;
} //end namespace seplib

typedef void (*FPcalcWeight)(int nd, const float* rr, float* wt);

#endif

