#include "stdafx.h"
#include "dmHeaderReader.h"

using namespace Yang;
void sepHeaderReader::getShape(hypercube &outShape, bool bRemoveDummyAxis)
{
  //Get the domain Information from the tag file
  VERIFY(!m_bDummy); //The tag has to be valid.
  
  std::vector<axis> mya;
    int n,i;
  
    n = getNumDataAxes(this->tag.c_str(), bRemoveDummyAxis);
    
    for(i=1; i <= n; i++)
    {
       mya.push_back(read_axis(i));
    }
    outShape.set_axes(mya);
    this->title=get_string("title","");
  
  //Get element Size
  bool bGrabFail = (0==auxpar("esize","d",&this->esize,this->tag.c_str()));
  if (bGrabFail) {
    this->esize = 4;
  }
}

void sepHeaderReader::getShape(hypercube &outShape, int n_axis_desired) {
  if (n_axis_desired>0) {
    this->getShape(outShape,false);
  } else if (n_axis_desired==0) {
    this->getShape(outShape,false);
  } else {
    this->getShape(outShape,true);
  }
  
  vecAxis axes = outShape.get_axes();
  int ndim = axes.size();
  if (ndim <= n_axis_desired) { //fill the other dimension with 1
    for (int i=ndim; i<n_axis_desired; i++) {
      axes.push_back(axis(1));
    }
  } else { //chop the dimension
    for (int i=ndim; i<n_axis_desired; i++) {
      VERIFY(axes.back().n == 1); //it has to be a dummy axis.
      axes.pop_back();
    }
  }
  outShape.set_axes(axes);
  return;
}

