#ifndef __DMRSFDUMP_H_INCL__
#define __DMRSFDUMP_H_INCL__

#include "dmRsf.hpp"
// TODO: your code here
//oc data specially for dump

namespace Yang {
template <typename T>
class dmRsf_ocDump: public dmRsf<T> {
protected:
	int m_dumpCnter;
public:
   dmRsf_ocDump(const string& itag, const string& szInfo, bool bNoDummy=false) : dmRsf<T> (itag,dm::OUT,szInfo,bNoDummy), m_dumpCnter(0) {
	  //if (bInput) //First get the dimension of data from the tag file
	  //{
		 //BAD, CALL VIRTUAL FUNCTION in CONSTRUCTOR!!!!
		 //this->getDomain(NULL);
	  //}
   }
   
   virtual ~dmRsf_ocDump();

   virtual void resetCounter() {
	   rsf<T>::resetCounter();
     if (!this->m_bDummy) {
       //Also reset the file pointer
       int offset=0; int origin=SEEK_SET;
       VERIFY(0==sseek(this->tag.c_str(),offset,origin));
     }
	}
   
  //IO access
   
  //Random access, in these cases cube is alloacted by the caller
  //virtual void grab3d(cubeData<T> * cube,  const windParam& wind);
  //virtual void grab2d(cubeData<T> * cube,  const windParam& wind);
  //virtual void grab1d(cubeData<T> * cube,  const windParam& wind);
  //virtual void grabXd(cubeData<T> * cube,  const windParam& wind, int ndim);

	//Grab a window of the object
  //virtual void grabWindow(cubeData<T> *cube,  const windParam& wind);
  
  //virtual void update1d(const cubeData<T> * cube,   const windParam& wind);
  //virtual void update2d(const cubeData<T> * cube,   const windParam& wind);
  //virtual void update3d(const cubeData<T> * cube,   const windParam& wind);
  //virtual void updateXd(const cubeData<T> * cube,   const windParam& wind, int ndim);
  //update a window of the data object 
  //virtual void updateWindow(const cubeData<T>* cube,const windParam& wind);
  
  //sequential access
  virtual void seq_grab		(cubeData<T>* cube) {}
  virtual void seq_update	(const cubeData<T>* cube) {}
	
	virtual void unInit();
	void dumpFrame(const cubeData<T>& cube);
};

template <typename T>
void dmRsf_ocDump<T>::dumpFrame(const cubeData<T>& cube) {
   //here we don't check the dimension or update the counter. because we don't know the last dimension.
  this->write_next(cube);
	this->m_dumpCnter++;
	axis ax_last(this->m_dumpCnter);
	int ndim = this->dom.get_ndim();
	dmRsf<T>::write_axis(ndim+1, ax_last);
	return;
}

template <typename T>
dmRsf_ocDump<T>::~dmRsf_ocDump() {}

template <typename T>
void dmRsf_ocDump<T>::unInit() {
	//axis ax_last(this->m_dumpCnter);
	//int ndim = this->dom.get_ndim();
	//dmRsf<T>::write_axis(ndim+1, ax_last);
	//!Cannot call unInit here, if called auxclose(tag.str()), the result history file will be erased and only 
	//the last axis information is left.
  
  dmRsf<T>::unInit();
}

}
#endif // __DMRSFDUMP_H_INCL__

