#ifndef G_VEC_H
#define G_VEC_H 1

//definition for generic vector
//Assume each generic vector might contain several 1D vectors
//also can present a intermediate gVec object, which points to some of the vector components 
//in the orginal gVec 

namespace Yang{
//abstract class Generic Vector
class gVec{
  public:
    gVec(){};
    virtual gVec *clone_vec() = 0;
    virtual gVec *clone_zero(){
      gVec *v=clone_vec();
      v->zero();
      return v;
    }
    virtual void allocate_space() = 0;
    virtual void scale(const double num){if(num==0)  assert(0==1);}

    //self vector = self*mes + vec*other
    virtual void scale_add(const double mes, gVec *vec, const double other) 
    {
    if(mes==0 || vec==0 || other==0)
      assert(0==1);
    }
      
    virtual double minval() = 0;
    virtual double maxval() = 0;
    virtual void set_val(double  val) = 0;
    virtual void add(gVec *vec) = 0;

    //self vec = self .* vec
    virtual void mult(gVec *vec) = 0;
    
    virtual double sum() = 0;

    //self vector = sc1*v1 + sc2*v2
    virtual void scale_add(const double sc1, gVec *v1,double sc2, 
       gVec *v2)
    {
         scale_add(0.,v1,sc1);
         scale_add(1.,v2,sc2);
    }
    
	
    virtual long long size() = 0;
    void zero(){ this->set_val(0.);}

    //compute dot product
    virtual double dot(gVec *vec){  assert(0==1);if(vec==0) return 0.;};
    virtual void info(char *str, int level=0){ if(str==0 && level==0) ; assert(0==1);};

    //fill in random values to gVec
    virtual void random() = 0;
    
    virtual ~gVec(){};

    virtual bool check_mismatch(const gVec *v2){
        if(name!=v2->name) return true;
        fprintf(stderr, "WARNING: TYPES DON'T MATCH %s %s \n",
         name.c_str(),v2->name.c_str());
        return false;
    }

    //members
    std::string name;

	};
}
#endif
