//#define the 2D gradient operator
#ifndef IGRAD2OP_H_INCLUDED
#define IGRAD2OP_H_INCLUDED 1

#include "decl_fwd.h"

namespace Yang {
class igrad2op {
  public:
  igrad2op (int n1, int n2, float d1=1.f, float d2=1.f) {
    n1_ = n1;  n2_ = n2;
    kd1_ = PosFloat(1.0f/d1); kd2_ = PosFloat(1.0f/d2);
  }
  virtual int oper(bool adj,bool add, cubeDataF& mod, cubeDataF& dat);
  
private:
  int       n1_,n2_;
  PosFloat  kd1_,kd2_;
};

class igrad3op {
  public:
  igrad3op (int n1, int n2, int n3) {
    n1_ = n1;
    n2_ = n2; n3_ = n3;
  }
  virtual int oper(bool adj,bool add, cubeDataF& mod, cubeDataF& dat);
  
private:
  int n1_,n2_,n3_;
};

} //end namespace
#endif // IGRAD2OP_H_INCLUDED

