#ifndef _intercept_h
#define _intercept_h


#include "point3d.hpp"
//Cut a line/plane along arbitrary slope in a 2D/3D cube
//

namespace Yang {
  
  template<typename T> //T could be point2d or point3d
  struct coords{
    public:
      T orig; //The origin of coord.
      T zdir,xdir; //The directions of z axis and x axis
      T ydir;
  };

//Intercept along the z direction as in seismic
void intercept2d(valarray<float>& line, const hypercube& outShape, const float* in, const hypercube& inShape, point2d<float> ic_orig, point2d<float> ic_dir,int iInterpType=0);
void intercept3d(valarray<float>& plane, const hypercube& outShape, const float* in, const hypercube& inShape, point3d<float> ic_orig,point3d<float> ic_dirz, point3d<float> ic_dirx, int iInterpType=0);

}
#endif
