#ifndef __INTERP_H_INCL__
#define __INTERP_H_INCL__



/**
 * TODO: Add class description
 * 
 * @author   yang
 */
//Grab from SEPLib, ther Interp module

namespace seplib {

   enum interpType{
	  nearest,
	  linear,
	  sinc
   };

class interp {

public:
   // Method to fetch singleton instance.
   static interp* getInstance();

   // Destructor
   virtual ~interp();
   
   //Interpolate
   void interpolate(Yang::cubeData<float>& out, Yang::cubeData<float>& in, int* pn1out, float* 
po1out, float *pd1out, int* pn2out, float* po2out, float* pd2out,int* pn3out, 
					float *po3out,float *pd3out,interpType type=seplib::sinc, int verb=0, int 
lsinc=10, int ntab=101, int maxsize=20); protected:
   // Constructor - protected so users cannot call it.
   interp();

   protected:
     float *sinc_table;
     bool bSincTableBuilt;
     int ntab_last, lsinc_last;
private: 
   // private static member referencing the single instance of the object
   // TODO: Replace interp with the type of object you want to
   // return the single instance of
   static interp* _instance;

   // Copy constructor
   // Declared but not defined to prevent auto-generated
   // copy constructor.  Refer to "Effective C++" by Meyers
   interp(const interp& src);

   // Assignment operator
   // Declared but not defined to prevent auto-generated
   // assignment operator.  Refer to "Effective C++" by Meyers
   interp& operator=(const interp& src);
};

// Constructor implementation
inline interp::interp(): sinc_table(NULL), bSincTableBuilt(false), ntab_last(0), lsinc_last(0)
{
}


// Destructor implementation
inline interp::~interp()
{
}

// TODO: Uncomment the copy constructor when you need it.
//inline interp::interp(const interp& src)
//{
//   // TODO: copy
//}

// TODO: Uncomment the assignment operator when you need it.
//inline interp& interp::operator=(const interp& rhs)
//{
//   if (this == &rhs) {
//      return *this;
//   }
//
//   // TODO: assignment
//
//   return *this;
//}

}
#endif // __INTERP_H_INCL__
