#ifndef __LINSOLVER_H_INCL__
#define __LINSOLVER_H_INCL__

#include "decl_fwd.h"

namespace Yang {
int simpLinSolver ( op& Fop, /* linear operator */
		    cdstepper& stepper, /* stepping function */
		    int nm, int nd,                /* size of model and data */ 
		    float* m,              /* estimated model */
		    const float* m0,       /* starting model */
		    const float* d,        /* data */
		    int niter,             /* iterations */
        stdVecFloat& errVec);

//Add data weight and mask weight
int solver(op& Foper,   //linear operator
                  cdstepper& stepper, //stepping function
                  int nm,             //size of model
                  int nd,             // size of dat
                  float* x,           // estimated model
                  const float* dat,   // data 
                  int niter,          // number of iterations
                  //rests are optional arguments
                  float* wt   = NULL, //data wt array
                  FPcalcWeight wtGen= NULL, //recalculate data wt
                  const float* x0 = NULL, //initial model
                  op*   nloper    = NULL, //nonline Operator !
                  const float* mwt= NULL, //model weight/mask array
                  int   verb = 1, //verbosity flag
                  const float* mmask= NULL, //model mask
                  const int*  p_nmem= NULL, //iteration memory
                  const int*  nfreq = NULL, //periodic restart
                  dmRsf_ocDump<float>* xmov= NULL, //model iterations
                  dmRsf_ocDump<float>* rmov= NULL, //data iterations
                  stdVecFloat*  err = NULL, //final fitting error for each iterations
                  cubeDataF*    res = NULL); //final residual

}//end namespace
#endif // __LINSOLVER_H_INCL__

