#ifndef __MISC_H_INCL__
#define __MISC_H_INCL__

#include "stdafx.h"
#include "interp.h"
#include "decl_fwd.h"

#define YPAUSE { \
      char c; \
      while (1) { \
        PRT_LOC; prt("program paused, press c to continue \n"); fflush(stderr); \
        c = getchar();  if (c=='c') break; } }

namespace seplib {
void callSepTool(Yang::cubeData<float>& outCube, const Yang::cubeData<float>& inCube, 
                 const std::string& toolName, const std::string& par,bool bAllocOutMemInside = false);

// Does OFF2ANG transform, if binverse=1 then does ANG to OFF transform
// 2D transform, The axis arrangement is (z,hx,x) <--> (z,ax,x)
// cube_transp is the variable for intermediate transpose result.
void off2ang(Yang::cubeData<float>& outCube, Yang::cubeData<float>& inCube, bool bInverse, float a_h_max);
} //end namespace

namespace Yang {
  //for FFT axis
inline void get_axis_inv(axis& ax_out, int n_out, const axis& ax_in) {
    char sztmp[512];
    sprintf(sztmp,"1/%s",ax_in.label.c_str()); ax_out.label= sztmp;
    sprintf(sztmp,"1/%s",ax_in.unit.c_str());  ax_out.unit = sztmp;
    ax_out.o = 0.0f; ax_out.n = n_out; ax_out.d = 1.f/(ax_out.n * ax_in.d);
  }

  //non-maximum suppression.
  struct NMSup_Param {
    PosInt wnd1_,wnd2_;
  };
  int nmSup(const cubeDataF& _in, cubeDataF& _out, const NMSup_Param* par);
  
  //Read an axis parameter from cmd line, the n,o,ds should be n-suffix,o-suffix,d-suffix.
  void read_axis_from_par(axis& ax, const param_func* pars, const string& suffix,int *ndef=NULL,float *odef=NULL,float *ddef=NULL);
  
  //find the first appearnce of val in an array, but with certain tolerance.
  template<typename _InputIterator, typename _Tp>
  inline _InputIterator findFirst(_InputIterator _first, _InputIterator _last, const _Tp& _val, const _Tp& tolerance) {
    while (_first != _last && ! (std::abs(*_first-_val)<=tolerance) ) ++_first;
    return _first;
  }
} //end namespace

#endif

