#ifndef MODELING_FD2D_OP_H
#define MODELING_FD2D_OP_H 1

#include "stdafx.h"
#include "waveOps.h"

namespace Yang{
class modelingFD2d_op : public modelingFD_op 
{
   public: //data member
		
	  //vel cube size, not wavefield cube size
      ETYPE m_dx,m_dz;

   virtual void propagate_2t(const cubeData<ETYPE>& p0cube, const cubeData<ETYPE>& p1cube, cubeData<ETYPE>& p2cube);
   virtual void propagate_4t(const cubeData<ETYPE>& p0cube, const cubeData<ETYPE>& p1cube, cubeData<ETYPE>& p2cube); //4th order in time

   public: //methods
      modelingFD2d_op(): modelingFD_op() {
      }
      //get the memory of wavefield arrays. !Notice this cannot be a virtual function, because the 
      //because the parameters interface is different for 2D and 3D
      void getWavefieldPtrs(ETYPE*** ppp0, ETYPE*** ppp1, ETYPE*** ppp2 );
      virtual void calcSpatialDeriv( cubeData<ETYPE> *in, cubeData<ETYPE> * out);

      void initOperator(waveOpParams* par,action_type ac);
protected:
   //For prestack-imaging
   virtual void corrWithOffset(cubeData<float>& offCubeOut, const cubeData<float>& wf1,const cubeData<float>& wf2);
	  
};

}

#endif


