#ifdef  _MY_DEUBG_H

#undef _MY_DEUBG_H

#undef PRT_LOC
#undef PRV
#undef PRV2
#undef PRV4
#undef PRV8
#undef PRVEC
#undef LOG
#undef TRACE
#undef FUNC_TRACE_BEG
#undef FUNC_TRACE_END

#endif //myDebug.h

//for stack-trace
extern std::vector<std::string> g_szVecCallStack;
extern char g_szCallStackTrc[];

#define _MY_DEUBG_H 1
#define PRT_LOC {cerr <<__FILE__<<":"<<__LINE__<<"; ";}

#ifdef DEBUG 
  //notice the assert macro uses NDEBUG, they are different
  //Cannot use printf because most cases the stdout is redirected, need to use stderr
  //#define VERB_PRT(args) {if (gVerb)  (printf("VERB: "), printf args);}
  #define PRV(x)  {cerr << __FILE__ <<":"<<__LINE__<<"; "<< #x "= " << x << endl;}
  #define LOG(word) \
  	if (gIsLogging) \
  		{cerr<<__FILE__<<":"<<__LINE__<<"; "<< #word << endl;}
  
  #define PRVEC(x,n) {cerr<<__FILE__<<":"<<__LINE__<<"; "<< #x "= "; \
  				    for (int k_v=0; k_v < n; k_v++) { \
  					cerr << (x)[k_v] << ", "; } \
              cerr << endl; }
  
  //For fprint expression
  #define TRACE(S) { PRT_LOC; prt S;}
  
  //NOTICE THAT this is NOT Thread-safe, because of accessing the std::vector with multiple threads.!!
  #define FUNC_TRACE_BEG(word) { {sprintf(g_szCallStackTrc,"\n %s:line %d; "#word,__FILE__,__LINE__);  \
						   g_szVecCallStack.push_back(std::string(g_szCallStackTrc));}
  #define FUNC_TRACE_END(ret) g_szVecCallStack.pop_back(); return ret; }

#else
  #define PRV(x)  {}
  #define LOG(word) {}
  #define PRVEC(x,n) {}
  #define TRACE(S) {}
  
  #define FUNC_TRACE_BEG(word) ;
  #define FUNC_TRACE_END(ret)  return ret;
#endif //end ifdef DEBUG

#define PRV2(x,y)     {PRV(x); PRV(y);}
#define PRV4(x,y,z,w) {PRV2(x,y); PRV2(z,w);}
#define PRV8(x1,x2,x3,x4,x5,x6,x7,x8) {PRV4(x1,x2,x3,x4); PRV4(x5,x6,x7,x8);}

#define SEEV(x)  {cerr << __FILE__ <<":"<<__LINE__<<"; "<< #x "= " << x << endl;}
#define SEEV2(x,y) {SEEV(x);SEEV(y);}
#define SEEVEC(x,n) { cerr<<__FILE__<<":"<<__LINE__<<"; "<< #x "= "; \
    for (int k_v=0; k_v < n; k_v++) {cerr << (x)[k_v] << ", "; } \
    cerr << endl; }
    

