#ifndef MYFFT_H
#define MYFFT_H

#include <fftw3.h>

namespace Yang { 
//Use FFTW to do fourier transform
enum FFT_IOtype {fft_r2c,fft_c2r,fft_c2c};

class FFT1d {
public:
  FFT1d(int N_in, bool bForward, FFT_IOtype iotype);
  ~FFT1d();
  void tf(const float* pr, fftwf_complex* pc, long long nTraces);
  void tf(const fftwf_complex* pc, float* pr, long long nTraces);
  void tf(const fftwf_complex* pc1, const fftwf_complex* pc2, long long nTraces);
  //void ft(float* pf, fftwf_complex* pc, int nTraces);
  
  int n_cmplx() {return n_cmplx_;}
private:
  std::vector<fftwf_complex*> mCmplxPtArray;
  std::vector<float*> mRealPtArray; //pointer array
  std::vector<fftwf_plan> mFFTplanArray;
  int nth_;
  int N_,n_cmplx_; bool bForward_; FFT_IOtype ioType_;
};
};

#endif
