#include "myOMP.h"
#include <iostream>
#include <omp.h>

using namespace std;

int g_NUM_THREADS = 1;
//init OMP, set the number of threads, //function should be executed only once
void init_omp(int numOfProcToSave)
{
  static int counter=1;
  if (counter==1) {
//#ifdef _OPENMP
  cerr<<"With openMP support"<<endl;
  int totalThreads = omp_get_max_threads();
  cerr<<"Max Num of threads avail: "<< totalThreads << endl;
  int num = totalThreads - numOfProcToSave;
  if (num<1) num=1;
  omp_set_num_threads(num);
  g_NUM_THREADS = num;
//#else
//  cerr<<"No OpenMP support"<<endl;
//#endif
  }
  counter++;
}

void change_omp(int numOfThreads) {
  #ifdef _OPENMP
	int totalThreads = omp_get_max_threads();
	int num = std::min(totalThreads,numOfThreads);
	omp_set_num_threads(num);
  g_NUM_THREADS = num;
  if (num < numOfThreads) {
    cerr<<"Warning: Max Num of threads avail: "<< totalThreads << "; ignore numOfThreads set by user: "<< numOfThreads << endl;
  }
#else
  fprintf(stderr,"No OpenMP support in change_omp\n");
#endif
  return;
}
