#ifndef YANG_TIMER_H
#define YANG_TIMER_H

#include "stdio.h"
#include "stdlib.h"
#include <time.h>

namespace Yang {
  class timer {
  public:
    timer () {
      time(&t_last_); //get the current time stamp
      sz_chkpt_ = "Clk created";
    }
    timer(string chkpt) {
      time(&t_last_); //get the current time stamp
      sz_chkpt_ = chkpt;
    }
    void reset(const string& chkpt) {
      time_t t_cur; time(&t_cur);
      double sec = difftime(t_cur,t_last_);
      fprintf(stderr,"%.f secs elapsed at chk pt %s from chk pt %s, and reset \n",
              sec,chkpt.c_str(),sz_chkpt_.c_str());
      sz_chkpt_ = chkpt; t_last_ = t_cur;
    }
    void check (const string& chkpt) {
      time_t t_cur; time(&t_cur);
      double sec = difftime(t_cur,t_last_);
      fprintf(stderr,"%.f secs elapsed at chk pt %s from chk pt %s\n",
              sec,chkpt.c_str(),sz_chkpt_.c_str());
    }
    ~timer() {
      time_t t_cur; time(&t_cur);
      double sec = difftime(t_cur,t_last_);
      //fprintf(stderr,"%.f secs elapsed at timer's end from chk pt %s\n",sec,sz_chkpt_.c_str());
    }
  private:
    time_t t_last_;
    string sz_chkpt_;
  };
} //end namespace Yang
#endif
