#ifndef __OBJFUNC_H_INCL__
#define __OBJFUNC_H_INCL__

namespace Yang {
  class gVecComponent;
   
// TODO: your code here
//Interface for objective function, it input a gVec as model, and provides a function as evaluate
//This is defined as pure interface.
class objFunc {
public:
   
   virtual float evaluate(const gVecComponent& model) = 0;
   virtual void  calcSearchDir( gVecComponent& searchDir, const gVecComponent& curModel) {}
   virtual void  callBackAtIter(int iIter) {} //Will be called by the solver at each iteration from iIter=1,2

   //retrieve or set calculated data.
   virtual const cubeData<float>& getCalcData() = 0;
   virtual string getCalcData_fn() {return string("");}
   virtual int   setCalcData(const cubeData<float>& data) {return 0;}
   virtual int   setCalcData_fn(const string& fn_data)    {return 0;}

   objFunc() {}
   virtual ~objFunc() {}
};

class opMatrixMultiply;
//For unit test, basically the operator is a dense matrix.
class simpleObjFunc: public objFunc {
public:
  simpleObjFunc(opMatrixMultiply* op, const cubeData<float>& data): m_opMultiply(op)  {
    data.copyTo(m_dat);
  }
  virtual float evaluate(const gVecComponent& model);
  virtual void  calcSearchDir( gVecComponent& searchDir, const gVecComponent& curModel);
  virtual cubeData<float>& getCalcData();
  
  virtual ~simpleObjFunc() {}
   
protected:
  opMatrixMultiply* m_opMultiply;
  cubeData<float> m_dat;
  cubeData<float> m_res;
};

}
#endif // __OBJFUNC_H_INCL__

