#ifndef OFF2ANG3D_H_ALOHA
#define OFF2ANG3D_H_ALOHA

#include "stdafx.h"
//Code adopted from BB
namespace Yang{

  enum gamma_khxy_mapping_method {gkm_NN,gkm_ap_NN,gkm_polyfill,gkm_triTexMapping}; //NN,area perserving bilinear, polygon fill, triangle texture mapping

  struct param_off2ang3d {
public:
  bool create_coplanar_stack, create_coplanar_ang,create_stack;
  int max_memory; //in Megabytes
  bool apply_jac_gamma, apply_jac_azim;
  int number_aliases;
  bool bSign_khy;
  hypercube shapeOff; //Should be 5 Dimension (hx,hy,kz,kmx,kmy), the hx/hy are not padded.
  hypercube shapeAng; //5-D (gamma,azim,kz,kmx,kmy)
  hypercube shape_zxy; //original z/x/y dimensions
  int n_hx_pad, n_hy_pad;
  string tag_coplanar_stack, tag_coplanar_ang;
  bool ang_2d;
  
  bool bVerb, boff2ang; //false then ang to off
  bool debug1,debug2;
  gamma_khxy_mapping_method m_mapping_method;
  bool  bDoFTsmoothing;
 
  //ax_gamma is also used for 2D 
  axis  ax_azim, ax_gamma; //axes for azimuth and reflectin angle
  
public:
  param_off2ang3d(): create_coplanar_stack(false),create_coplanar_ang(false),create_stack(false),max_memory(500), apply_jac_gamma(false), apply_jac_azim(false),number_aliases(0),
    boff2ang(true),debug1(true),debug2(false),m_mapping_method(gkm_ap_NN),bDoFTsmoothing(false) {}
  };

//Define the class that implements the off2ang3d Operator
template <typename T>
class dmRSF;

//fwd/bwd pairs.
void off2ang3d(param_off2ang3d& par, dmRsf<cmplxf>& dm_in, dmRsf<cmplxf>& dm_out);
void ang2off3d(param_off2ang3d& par, dmRsf<cmplxf>& dm_in, dmRsf<cmplxf>& dm_out, bool bDoFTsmoothing);

//The below function includes the one above
void off2ang3d_file(param_off2ang3d& par, string& sz_inFn, string& sz_outFn);
void ang2off3d_file(param_off2ang3d& par, string& sz_inFn, string& sz_outFn);

}
#endif
