#ifndef OP_H
#define OP_H

#include "hypercube.h"
#include "decl_fwd.h"
//#include "gVec.h"

namespace Yang {
class op  //Define the class of operator
{
public:
  //The user should make sure that the shape in mod and dat is consistent of the members, modShape and datShape
  void setShape(const hypercube& _modSh, const hypercube& _datSh) {
    modShape = _modSh;
    datShape = _datSh;
  }
  
  virtual void oper(cubeData<float>& mod, cubeData<float>& dat, bool bAdj, bool bAdd) {VERIFY(0);}
  virtual void oper(bool bAdj, bool bAdd, int nmod, int ndat, float* mod, float* dat);
    
  bool dot_test(bool verbose=true); //test fwd/adj pair
  bool linearity_test(bool bAdj, bool verbose=true); //test operator linearity.
   
  virtual ~op() {
  }
  
  const hypercube& ModShape() const {
    return modShape;
  }
  const hypercube& DatShape() const  {
    return datShape;
  }
  
protected:  
  hypercube modShape, datShape;
};
} //end namespace
#endif

