#include "commonOps.h"
#include "stdafx.h"

namespace Yang {
  //define the smoother Interface
  class smoother_intf {
  public:
    virtual ~smoother_intf() {}
    //n n==0 means no smoothing on that dimension.
    virtual int setSmoothScale( const stdVecInt& nNodesVec, const hypercube& shape_input) = 0;
    virtual void smooth(cubeData<float>& in, cubeData<float>& out, int repeat=1) = 0;
  };
  
  // Spline smoothing, From Xukai Shen, Reference See Biondo's Thesis
  class opSpline: public op, public smoother_intf {
public:
  virtual ~opSpline() {}
  void init(const hypercube &modShape, const hypercube& datShape);
  virtual void oper(cubeData<float>& mod, cubeData<float>& dat, bool bAdj, bool bAdd);

  virtual int setSmoothScale( const stdVecInt& nNodesVec, const hypercube& shape_input);
  virtual void smooth(cubeData<float>& in, cubeData<float>& out, int repeat);
protected:
  std::vector<bool> mSkipAxis;
};

  // Smooth using the triangle smoothing defined in SEP tool smooth
  class smoother_seplib: public smoother_intf {
  public:
    virtual int setSmoothScale(const stdVecInt& nNodesVec, const hypercube& shape_input);
    virtual void smooth(cubeData<float> &in, cubeData<float> &out, int repeat);
    
  public:
    stdVecInt ns_input, nsHfWids;
  };
  
}
