#ifndef __PADDINGFD_DAMPING_H_INCL__
#define __PADDINGFD_DAMPING_H_INCL__

#include "paddingFD.h"
#include "dampingFunc.h"

namespace Yang {
/**
 */
   
class paddingFD2dDamping:public paddingFD2d{
public:
   cubeData<ETYPE> m_mult_cb; //Multiplier used in updating wavfield.
   
   //Damping function, that creates a coef from 1.0->0.0 within window length
   dampingFunc* m_pDampingFunc;
   float mDampingExtent; //0.0~1.0, 1.0 is the strongest.
public:
	// Constructor
	paddingFD2dDamping(paddingFD* pNextPaddingObj, float dampingExtent)
	:paddingFD2d(pNextPaddingObj) {
	   this->setDampingExtent(dampingExtent);
	}

	// Destructor
	virtual ~paddingFD2dDamping() {}

	// Copy constructor
	// TODO: Uncomment the copy constructor when you need it.
	//paddingFD_damping(const paddingFD_damping& src);

	// Assignment operator
	// TODO: Uncomment the assignment operator when you need it.
	//paddingFD_damping& operator=(const paddingFD_damping& src);
	void setDampingExtent(float extent) {
	   VERIFY(extent>=0.0f && extent<=1.0f);
	   mDampingExtent = extent;
	}
	
	virtual void initOperator(waveOpParams *par);
	virtual void update(wavFieldGroup& wfg);
};

// TODO: Uncomment the copy constructor when you need it.
//inline paddingFD_damping::paddingFD_damping(const paddingFD_damping& src)
//{
//   // TODO: copy
//}

// TODO: Uncomment the assignment operator when you need it.
//inline paddingFD_damping& paddingFD_damping::operator=(const paddingFD_damping& rhs)
//{
//   if (this == &rhs) {
//      return *this;
//   }
//
//   // TODO: assignment
//
//   return *this;
//}

}

#endif // __PADDINGFD_DAMPING_H_INCL__
