
#ifndef SEP_PARAMS_H
#define SEP_PARAMS_H 1

//#include<float_1d.h>
#include "param_func.h"
//Convert a string to upper case
inline void toUpper(string& str) {
   for(int x=0; x<int(str.length()); x++)
	  str[x] = char(toupper(str[x]));
}

class sep_params:public param_func{
  public:
  
    sep_params(){} //Default constructor does nothing
    sep_params(int argc, char **argv);
    sep_params(int argc, char **argv, char *prog);

    virtual bool is_input_file(const std::string& tag) const;
    virtual bool is_inout_file(const std::string& tag) const;

    virtual int get_int(const string& arg)          const; // arg: the param's key
    virtual int get_int(const string& arg, int def) const; //def: default value if not fetched

    virtual bool get_bool(const string&arg)        const;
    virtual bool get_bool(const string&arg, bool def) const;
    
    virtual float get_float(const string&arg)            const;
    virtual float get_float(const string&arg, float def) const;
    virtual float *get_floats(const string&arg, int nmax,float *def, int* p_nRead) const;
    
    std::string get_string(const string&arg) const;
    std::string get_string(const string&arg, string def) const;
    //Get arrays from one param entry, e.g lag=1,2,3,4,5
    int *get_ints(const string&arg, int nmax, int* p_nRead) const; 
    int *get_ints(const string&arg, int nmax, int *def, int* p_nRead) const;
    
    virtual void error(const std::string&) const;


     
 };
#endif
      

