#include "stdafx.h"

#include "srcWav.h"
#include "interp.h"
#include "cubeAlgo.h"
using namespace Yang;

srcWav::~srcWav() {
   //There is A BUG I COULDN'T figure out, if I delete the obj, it will give segmentation fault !!!!!!
   //SAFE_DELETE(m_pInterpWavelet);
   }

//Interp the wavelet from its original sampling to dt
//Remember not only Interp, BUT ALSO take the 2nd derivative
void srcWav::InterpWavelet(ETYPE dt, bool bTake2ndDeriv){
  //Get the original sampling
  //float dt_orig = this->domain().get_d(1);
  //verbPrt("original wavelet sampling:%f\n",dt_orig);
  assert(m_pInterpWavelet);
  
  //default sinc interpolation, just 1d case
  float d1out = dt;
  
  //just do 1d interpolation  
  seplib::interp::getInstance()->interpolate(*m_pInterpWavelet,*(this),
                                                                          NULL,NULL,&d1out,
                                                                          NULL,NULL,NULL,
                                                                          NULL,NULL,NULL, seplib::sinc);
  //NOTICE!! CANNOT USE LINEAR interpolation if Take 2nd derivatives.
  //bTake2ndDeriv = false;
  //After Interpolation, 
  if (bTake2ndDeriv) {
    cubeData<float> interpWavelet;
    m_pInterpWavelet->copyTo(interpWavelet);
    //Take 2nd Derivative
    timeDeriv2nd(*m_pInterpWavelet,interpWavelet,true);
  }
  //m_pInterpWavelet->dump("dump");
}
   
cubeData<float>* srcWav1d::getWavelet() {
   return srcWav::getWavelet();
}

void srcWav1d::loadWavelet() {
   assert(canInput()); this->init(NULL,1);
   VERIFY(this->domain().get_ndim() == 1);
}
