#ifndef SRCWAV_H
#define SRCWAV_H 1

#include "cubeData.hpp"
#include "sep_params.h"

namespace Yang{

class srcWav : public cubeData<float> {
//supposedly src wavelet should be a 1D array
public:   
   enum waveletType
   {
      ricker0, //Guassian 
      ricker1, //1st deriv of Gaussian
      ricker2, //2nd deriv of Gaussian
      other
   } m_wavType;
   float m_pFreq; //Center frequency of wavelet,should read this param from wavelet file

   cubeData<float> *m_pInterpWavelet;  //The interpolated wavelet
public: //methods
   srcWav(string itag, dm::typeIO _tIO, const string& szInfo): cubeData<float>(itag,_tIO,szInfo),m_pFreq(0.0f), m_pInterpWavelet(NULL) {
	  m_pInterpWavelet = new cubeData<float>();
      }
   virtual ~srcWav();
   
   virtual void loadWavelet() = 0;
   
   void  setPeakFreq(float fpeak) {
	  m_pFreq = fpeak;
   }
   float getPeakFreq() {
      return m_pFreq;
   }
   //suppose the input wavelet is sampled with m_dtRec(or any other value), this function 
   // just interpolates the wavelet to a sampling rate of dt(assumeably dt=m_dtComp)
   virtual void InterpWavelet(ETYPE dt, bool bTake2ndDeriv);
   virtual cubeData<float> * getWavelet() {
      assert(m_pInterpWavelet);
      return m_pInterpWavelet;
   }  
};

class srcWav1d: public srcWav
{
   public: //methods
      srcWav1d(string itag, dm::typeIO _tIO, const string& szInfo): srcWav(itag, _tIO,szInfo) {
      }
      virtual cubeData<float> * getWavelet();
	  virtual void loadWavelet();
};

}
#endif
