#include "stdafx.h"

#include "streamlist.h"
#include "tagHack.h"
#include "cubeData.hpp"
//Now we should be able to access the file with name $(filename), use the tags we created. 
//But make sure to randomize both the tag and the filename

int Yang::addNewSepTag( const char *tag, bool bInput, const char* fileName )
{
  //Should first check the tag is not preexist
  streaminf *newinf;
  /* temporary buffer for strings from par line, max length=4096 */
  char tmppar[4096];

  newinf = (streaminf*) malloc(sizeof(streaminf));

  newinf->tagname = (char*)malloc(1+(int)strlen(tag));
  strcpy(newinf->tagname,tag);


  if( bInput == false ) {newinf->entrytype = STREAMOUT;} 
  if( bInput == true )  {newinf->entrytype = STREAMIN; }
  //if( type == TAG_INOUT ) newinf->entrytype = STREAMINOUT;
  
  /* headername is either tagname or par associated with the tag */
  /* the special cases "in" and "out" have parnames "stdin" and "stdout" */
  /* headername is either a filename, a pipe command or a machine:port pair */
  
  strcpy(tmppar,fileName);
  newinf->headername=(char*)malloc(1+(int)strlen(tmppar));
  strcpy(newinf->headername,tmppar);
/*  newinf->headfile=(FILE*)0;*/
/*  newinf->headfile=SEPPOINTNULL;*/
  newinf->headfile=0;

  /* initialize everything to sensible null values */
  newinf->valid = 1;
  newinf->headerbuf=0; newinf->hdrlen=0;
  newinf->hetch_queue=0; newinf->hqlen=0;
  newinf->tetch_queue=0; newinf->tqlen=0;
  newinf->backseekable = 0;
  newinf->header_title=0;
  newinf->header_outname=0;
/*  newinf->headerformatfile=alloc(1);*/
  newinf->headerformatfile=0;
  newinf->gridformatfile=0;
  // newinf->distribformatfile=0;
  newinf->key_bytes=0;
  newinf->ready_out=0;
/*  newinf->dataname=alloc(1);*/
  newinf->dataname=0;
  newinf->format_num=-1;
  newinf->iotype=FILE_IO;
  newinf->ioinf=0;
  newinf->streamfile=0;
/*  newinf->streamfile=SEPPOINTNULL;*/
  newinf->streamfd=-1;
  newinf->open_func=0;
  newinf->close_func=0;
  newinf->read_func=0;
  newinf->write_func=0;
  newinf->seek_func=0;
  newinf->size_func=0;
  newinf->isapipe=0;
  newinf->sockfd=0;

	newinf->n_key=-1;
  
  //Now we have this entry, add it to the global list of (tag,filename pairs)
  sepstr_addend(newinf);
  
  //Initialize the file ptrs
  switch( newinf->entrytype ){
     case STREAMIN:
        sepstr_in_head( newinf );
        break;
     case STREAMOUT:
        sepstr_out_head( newinf);
        break;
     case STREAMINOUT:
        sepstr_inout_head( newinf );
        break;
     case STREAMSOCKOUT:
        sepstr_socket_head( newinf );
        break;
     case STREAMSCR:
        sepstr_scr_head( newinf );
        break;
  default:
    VERIFY(0);
  }
  return 0;
}

void Yang::readSepFileUsingFileName(
      cubeData<float>& data,const string& tag, const string& fileName,
      bool bAllocMemoryInside) {
  FUNC_TRACE_BEG(Yang::readSepFileUsingFileName);
  addNewSepTag(tag.c_str(),true,fileName.c_str());
  dmRsf_oc<float> dat_oc(tag.c_str(),dm::IN,"",true);
  dat_oc.init(NULL);
  if (bAllocMemoryInside) {
    data.alloc(dat_oc.domain());
  } else {
    VERIFY(data.domain().sameSize(dat_oc.domain()));
  }
  dat_oc.seq_grabAll(&data);
  dat_oc.unInit();
  FUNC_TRACE_END();
}

