
#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"

using namespace Yang;
using namespace std;

//Test for Bspline smoothing.
int main( int argc, char** argv){
  
   //Read params
   auto_ptr<sep_params> pars(new sep_params(argc,argv));
   
   hypercube datShape;
   
   //Read in a .H file and smooth it
   cubeData<float> in("in",dm::IN,"input");
   in.init(NULL,true);
   datShape = in.domain();
   LOGC(s0);
   
   datShape.info("dat Shape");
   //Read in the desired mod shape
   int ndim = datShape.get_ndim();
   PRV(ndim);
   VERIFY(ndim<=3);
   
   LOGC(s1);
   //Build a window to extract the zero slice on axis2
   windParam wind(ndim);
   wind[1].f = datShape.get_n(2)/2;
   wind[1].n = 1;
   LOGC(s2);
   //Set the size of outCube;
   vecAxis axes = datShape.get_axes();
   axes.erase(axes.begin()+1);
   
   LOGC(s3);
   cubeData<float> out(axes);
   out.info("out");
   
   in.grabWindow(&out,wind);
   LOGC(s4);
   out.dump("output");
   in.unInit();
}


