#include "stdafx.h"
#include "cubeData.hpp"
#include "myOMP.h"
#include "stackTraceC.h"
#include "commonOps.h"
#include "sep_params.h"
#include "linSolver.h"

using namespace Yang;
using namespace std;

   
//Test the linear solver algorithm with the matrix multiplication problem.

int main (int argc, char *argv[])
{
  initCallStackTrace();
  sep_params* pars = new sep_params(argc,argv);
  opMatrixMultiply op;
  cubeData<float> matr,dat,mod0,mod;
  
  int m,n;
  
  LOGC(m1sdf);
  //read in the matrix
  matr.load("mat",2);
  LOGC(m2);
  hypercube shpm = matr.domain();
  m = shpm.get_n(2); n = shpm.get_n(1);
  
  PRV2(m,n);

  matr.info("matr info");
  
  op.init(matr);
    
  dat.load("dat",1);
  
  assert(n == dat.domain().get_n123());
  
  hypercube shpmod(m);
  mod.alloc(shpmod); mod0.alloc(shpmod);

  LOGC(m3);
  cdstepper stepper(m,n);
  int niter = pars->get_int("niter",10);
  
  int sret; 
  stdVecFloat errVec(0);
  
  LOGC("enter simp LinSolver");
  PRV2(m,n);
  sret = simpLinSolver(op, stepper, m,n, mod.getDataPtr(), (float*)NULL, dat.getDataPtr(), niter, errVec);
  LOGC("exit simp LinSolver");
  
  mod.dump("out",true);
  
  PRVEC(errVec,errVec.size());
  dumpStdVec(errVec,"err");
  return 0;
}

