#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"

#include "commonOps.h"
#include "imaging.h"

//operators

using namespace Yang;
using namespace std;

//Dot Prod test for OpInterpLinear
int main( int argc, char** argv){
  
   //Read params
   auto_ptr<sep_params> pars(new sep_params(argc,argv));
   
   opOff2slope myOp;
   //forward off to angle, backward angle to off
   
   //Just input two cube for the geometry
   sepHeaderReader mod1("off",dm::IN,"mod shape");
   sepHeaderReader dat1("slope",dm::IN,"dat shape");
   
   hypercube modShape,datShape;
   mod1.getShape(modShape,true); dat1.getShape(datShape,true);

   bool bUseAntialias = pars->get_bool("b_AA",false);
   float faa = pars->get_float("f_AA",1.0f);
   PRV(faa); PRV(bUseAntialias);
   myOp.init(modShape,datShape,bUseAntialias,faa);
   myOp.dot_test();
}


