#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "stackTraceC.h"
#include "commonOps.h"
#include "imaging.h"

//operators

using namespace Yang;
using namespace std;

//Dot Prod test for OpInterpLinear
int main( int argc, char** argv){
   initCallStackTrace();
   //Read params
   auto_ptr<sep_params> pars(new sep_params(argc,argv));
   opMoveoutSemblance myOp;
   
   //Just input two cube for the geometry
   sepHeaderReader mod1("mod",dm::IN,"mod shape");
   sepHeaderReader dat1("dat",dm::IN,"dat shape");
   
   hypercube modShape,datShape;
   MOtype moveOutT = Yang::Quadratic;
   
   mod1.getShape(modShape,true); dat1.getShape(datShape,true);

   float faa = pars->get_float("f_AA",1.0f);
   PRV(faa);
   myOp.init(modShape,datShape,moveOutT,faa);
   myOp.dot_test();
}


