#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "cubeAlgo.h"

using namespace Yang;
using namespace std;

//Do cross correlation on time axis
//C(tau)[in1,in2] = sigma_{t}{in1(t-tau)in2(t)} = sigma_{t}{in1(t)in2(t+tau)}
//here assume both input traces
int main( int argc, char** argv){
   
   //Read params
   boost::shared_ptr<sep_params> pars(new sep_params(argc,argv));
   
   
   //out is the correlation result. No normalization is applied
   
   cubeDataF file1("f1",dm::IN,"model1");   file1.init(NULL,true);
   cubeDataF file2("f2",dm::IN,"model2");    file2.init(NULL,true);
   cubeDataF result("",dm::OUT,"model2");
   
   


   
   //params.
   int iStartLag = 0, iEndLag = 0;
   iStartLag = pars->get_int("startLag");
   iEndLag = pars->get_int("endLag");
   
   //crossCorr1dGeneral(result,file1,file2,iStartLag,iEndLag);
   crossCorr1dGeneral(result,file1,file2,iStartLag,iEndLag);
   
   dmRsf_oc<float> output("out",dm::OUT,"data");
   output.init(&result.domain());
   output.seq_update(&result);
   output.unInit();
   
   file1.unInit(); file2.unInit();
}

