#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"


using namespace Yang;
using namespace std;

//Calculate a dateset that is the culumation along the first axis. If not first axis, then Transpose
//it before input
int main( int argc, char** argv){
   
   //Read params
   auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
   
   //in is the model
   //out is the gradiant
   cubeDataF input("in",dm::IN,"model");
   cubeDataF output("out",dm::OUT,"data");
   
   input.init(NULL);
   output.init(&(input.domain()));
   
   
   int ntrc = output.domain().get_n23();
   long long i;
   int j,nt;
   
   //Get the data pointers
	float *pOut,*po;
	const float* pIn, *pi;
	pIn   = input.getDataPtr();
	pOut  = output.getDataPtr();
	pi = pIn;
	po = pOut;
	
	nt = output.domain().get_n(1);
	
    float sum;
	for(i=0;i<ntrc;i++)
	{
	   pi = pIn+i*nt;
       po = pOut+i*nt;
       sum = 0.0f;
	   for(j=0;j<nt;j++)
	   {
		  sum += pi[j];
          po[j] = sum;
	   }
	}
       
   input.unInit();
   output.unInit();
}

