#include "stdafx.h"
#include "sep_params.h"
#include "dmCube.h"

using namespace Yang;
//Program to run a 1D polynomial division Y(z) = X(z)/A(z)
int main( int argc, char** argv){
   //Read params
   auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
   sep_params* pars = autoPars.get();
   
   auto_ptr< dmCube> X(new dmCube("in",true,"inputX"));
   auto_ptr< dmCube> A(new dmCube("filter",true,"inputFilter"));
   auto_ptr< dmCube> Y(new dmCube("out",false,"result"));
   
   X->init(NULL);
   A->init(NULL);
   
   cubeData<float> outCube;
   const cubeData<float> *pX, *pA;
   pX = X->m_pData;
   pA = A->m_pData;
   int length = X->domain().get_n(1);
   VERIFY(X->domain().get_n123() == X->domain().get_n(1));
   polydiv(*pX,*pA,outCube,length);
   
   Y->init(&(X->domain()));
   Y->updateAll(outCube);
   Y->save();
}
