#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "cubeAlgo2.h"
#include "stackTraceC.h"
using namespace Yang;
using namespace std;

//Shuffle Axis, manipulation, but is not optimized and only incore. Therefore only suit for small data.
int main( int argc, char** argv){
   initCallStackTrace();
   //Read params
   auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
   
   //in is the model
   //out is the gradiant
   
   cubeDataF input("in",dm::IN,"model");
   cubeDataF out;
   input.init(NULL);
   
   //Take the time derivative
   int nmax=20;
   int n1,n2;
   int* reshape = autoPars->get_ints("reshape",nmax,&n1);
   int* mapping = autoPars->get_ints("mapping",nmax,&n2);
   VERIFY(n1==n2);
   
   stdVecInt v1(reshape,reshape+n1),v2(mapping,mapping+n1);
   PRVEC(v1,v1.size());
   
   
   Yang::shuffleAxis(out,input,v1,v2,true);
   input.unInit();
   out.dump("output");
}

