#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "cubeAlgo.h"
#include "cubeAlgo2.h"

using namespace Yang;
using namespace std;

int main( int argc, char** argv){
   
   //Read params
   auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
   
   //in is the model
   //out is the gradiant
   
   
   cubeDataF input("in",dm::IN,"model");
   cubeDataF output("output",dm::OUT,"data");
   
   int iAxis = autoPars->get_int("axis");
   input.init(NULL,true);

   LOG(L1);
   //output.init(&(input.domain()));
   vecAxis axes = input.domain().get_axes();
   axes.erase(axes.begin()+iAxis-1);
   hypercube outShape(axes);
   output.init(&outShape);
     
   axis ax1 = input.domain().get_axis(iAxis);
   int index = ax1.get_offset(0.0f);
   LOG(L2);
   //Take the time derivative
   int order = autoPars->get_int("order",0);
   switch(order) {
   case 0:
	  break;
   case 1:
	  deriv1stAtIndex(output,input,iAxis,index,false); break;
   case 2:
	  deriv2ndAtIndex(output,input,iAxis,index,false); break;
   default:
	  seperr("\norder pls specify!!");
   }
   LOG(L3);
   input.unInit();
   output.unInit();
}

