#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"

#include "commonOps.h"
#include "cubeAlgo.h"
#include "cubeAlgo2.h"

using namespace Yang;
using namespace std;

//Test for Bspline smoothing.
int main( int argc, char** argv){
  
   //Read params
   auto_ptr<sep_params> pars(new sep_params(argc,argv));
   
   hypercube modShape;
   hypercube datShape;
   
   //Read in a .H file and Stack and spread it.
   cubeData<float> in("in",dm::IN,"input");
   in.init(NULL,true);
   
   datShape = in.domain();
   
   datShape.info("in Shape");
   
   int iax = 1;
   cubeData<float> modStack;
   vecAxis axes = datShape.get_axes(); axes.erase(axes.begin()+iax);
   modShape.set_axes(axes); modStack.alloc(modShape);
   multAndStackAlongAxis2(modStack, in, NULL);
   float f_nt = float(datShape.get_axis(2).n);
   modStack.scale(1.0f/f_nt);
   
   cubeData<float> out;
   out.alloc(datShape);
   duplicateAlongAxis( out,  modStack, iax+1);
   out.dump("out");
   in.unInit();
   return 0;
}


