#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"

using namespace Yang;
using namespace Yang;

///Strip out the dummy Axis from the input data file
///The dummy Axis are those defined in the middle of the axes.(Not the first and the last axis)
///with n=1 d=1 o=0
int main(int argc, char* argv[]) {
	//have to init par
	sep_params* pars = new sep_params(argc,argv);

  sepHeaderReader inputInfo("in",dm::IN,"input");
    
	
	hypercube inShape,outShape;
	bool bRemoveEndDummyAxis = true;
	inputInfo.getShape(inShape,bRemoveEndDummyAxis);
	vecAxis inAxes = inShape.get_axes();
	
	bool bIsDummy;
	vecAxis outAxes;
	//Push the first axis
	outAxes.push_back(inAxes[0]);
	for (unsigned int i=1; i<inAxes.size()-1; i++) {
		const axis& ax = inAxes[i];
		//bIsDummy = (ax.n==1 && equalf(ax.d,1.0f) && equalf(ax.o,0.0f));
		bIsDummy = (ax.n==1);
		if (!bIsDummy) {
			outAxes.push_back(ax);
		}
	}
	//Add the last axis
	outAxes.push_back(*(inAxes.end()-1));
	outShape.set_axes(outAxes);
	inShape.info("inShape");
	outShape.info("outShape");
    
    int esize = inputInfo.getElemSize();
    if (esize==4) {
       cubeData<float> in("in",dm::IN,"input");
       cubeData<float> out("output",dm::OUT,"output");
       VERIFY(!out.isDummy());
       in.init(NULL,bRemoveEndDummyAxis);
       if (!in.domain().sameSize(outShape)) {
         in.reshape(outShape);
       }
       out.init(&outShape);
       out.seq_update(&in);
       in.unInit();
       out.unInit();
    } else  {
       cubeData< ::complex> in("in",dm::IN,"input");
       cubeData< ::complex> out("output",dm::OUT,"output");
       VERIFY(!out.isDummy());
       in.init(NULL,bRemoveEndDummyAxis);
       if (!in.domain().sameSize(outShape)) {
         in.reshape(outShape);
       }
       out.init(&outShape);
       out.seq_update(&in);
       in.unInit();
       out.unInit();
    }
    return 0;
}



