#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "cubeAlgo.h"

using namespace Yang;
using namespace std;

int main( int argc, char** argv){
   
   //Read params
   auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
   
   //in is the model
   //out is the gradiant
   
   
   cubeDataF input("in",dm::IN,"model");
   cubeDataF output("out",dm::OUT,"data");
   
   input.init(NULL);
   output.init(&(input.domain()));
   
   //Take the time derivative
   int order = autoPars->get_int("order",0);
   switch(order) {
   case 0:
	  break;
   case 1:
	  timeDeriv1st(output,input,false); break;
   case 2:
	  timeDeriv2nd(output,input,false); break;
   default:
	  seperr("\norder pls specify!!");
   }
   
   input.unInit();
   output.unInit();
}

