#include "stdafx.h"
#include "stackTraceC.h"
#include "cubeData.hpp"
#include "sep_params.h"
#include "misc.h"
#include "LUsolver.h"

/**
 * Main application entry point
 * 
 * Solve a n by n small linear equaiton system, test the numerical recipe code.
 */
      
using namespace Yang;
using namespace std;

int main (int argc, char *argv[])
{
  // TODO: Add application code here
  initCallStackTrace();
  init_omp(100);
  
  //have to init par
	sep_params* pars = new sep_params(argc,argv);
  
  bool bNotDummy = true;;
  cubeDataF dmIn("in",Yang::dm::IN,"input",bNotDummy);  cubeDataF dmOut("out",Yang::dm::OUT,"output",bNotDummy);
  cubeDataF dm_mat("mat",dm::IN,"matrix",bNotDummy);
  dmIn.init(NULL,2); dm_mat.init(NULL,2);
  int n = dm_mat.domain().get_n(2);
  VERIFY( n == dmIn.domain().get_n(1));
  dmOut.init(&dmIn.domain());
  dmOut = dmIn;
  
  luSolve(dm_mat,n, &dmOut[0]);
  return 0;
}
