#ifndef UTIL_SEPLIB_H
#define UTIL_SEPLIB_H 1

#include "stdafx.h"
#include "decl_fwd.h"

namespace seplib {

struct AGC_Param {
public:
  void readParam(const param_func* pars, const Yang::hypercube& shp0, const string& prefix=string() );
  AGC_Param():nw1_(1),nw2_(1),normPow_(2) {}
public:
  PosInt nw1_,nw2_,nw3_; //size of sliding windows on the 1st and 2nd axes.
  PosInt normPow_;  //the norm used for computing power.
};

int AGC(const Yang::cubeDataF& _in, Yang::cubeDataF& _out, const AGC_Param* par, NnegInt divideTimes = NnegInt(1)); //add 2-D implementation.
int AGCdivide(const Yang::cubeDataF& _in, const Yang::cubeDataF& _inDenom, const Yang::cubeDataF* pMask, Yang::cubeDataF& _out, const AGC_Param* par, NnegInt divideTimes = NnegInt(1)); //add 2-D implementation.

int divideByTiles(const Yang::cubeDataF& _in, const Yang::cubeDataF& _inDenom, Yang::cubeDataF& _out, const AGC_Param* par, NnegInt divideTimes = NnegInt(1));


} //end namespace

#endif

