#include "stdafx.h"
#include "param_func.h"
#include "velAna.h"

#include "FWI_FD.h"
#include "FWI_FD_beamFocus.h"

#include "velAna.param.h"
#include "param_entry.h"

using namespace Yang;

void Yang::read_FWI_param(FWI_Param *pFWIparam, param_func* pars) {
  FWI_Param& FWIparam = *pFWIparam;
  //Load the corrlation window
  FWIparam.iStartLag = pars->get_int(csz_corrStartLag);
  FWIparam.iEndLag = pars->get_int(csz_corrEndLag);
  return;
}

FWI_FD* Yang::create_FWI_obj(velAnaParam* pVApar, waveOpParams* pModelPar, modelingFDgen_op* pModelingObj, FWI_Param* pFWIpar, param_func* pars) {
  bool bTaperEdge = true; //Has to be true!
  int objFuncIndex = pars->get_int("objFunc",1);
  FWI_FD* pFWIObj;
  FWI_Param& fwiPar = *pFWIpar;
  switch(objFuncIndex) {
   case 1: 
    prt("using classical FWI obj Function");
    fwiPar.mFWItype = FWI_Param::classic; 
    pFWIObj = new FWI_FD_classic(pVApar,pModelPar,pModelingObj,pFWIpar);
    break;
   case 2: 
    prt("using YiLuo FWI obj Function");
    fwiPar.mFWItype = FWI_Param::YiLuo; 
    pFWIObj = new FWI_FD_YL(pVApar,pModelPar,pModelingObj,pFWIpar);
    break;
   case 22: 
    prt("using YiLuo2 FWI obj Function");
    fwiPar.mFWItype = FWI_Param::YiLuo2; 
    pFWIObj = new FWI_FD_YL2(pVApar,pModelPar,pModelingObj,pFWIpar);
    break; 
   case 3: 
    prt("using beam focusing1 FWI obj Function\n");
    fwiPar.mFWItype = FWI_Param::beamFocusing1;
    pFWIObj = new FWI_FD_beamFocus1(pVApar,pModelPar,pModelingObj,pFWIpar,bTaperEdge);
    break;
   default:
    seperr("wrong  objFunction index\n");
    exit(-1);
  }
  return pFWIObj;
}

