#ifndef  FWI_FD_DSO_H
#define  FWI_FD_DSO_H

#include "FWI_FD.h"

namespace Yang {
   
class FWI_FD_DSO: public FWI_FD {
public:
   FWI_FD_DSO(velAnaParam* pVelAnaParam, waveOpParams* pFDModelingParam, 
			  modelingFDgen_op* pModel, FWI_Param * pPar,bool bTaperEdge) : FWI_FD(pVelAnaParam, pFDModelingParam, pModel, pPar), m_bTaperEdge(bTaperEdge) {}
   virtual void calcBackProjData() = 0;
   virtual float calcObjFunc();
   virtual void postCalcData();
public:
	bool m_bTaperEdge;
	
protected:
	virtual void flipGradient(cubeData<float>& gradCube);
};

class FWI_FD_DSO1 : public FWI_FD_DSO {
public:
   FWI_FD_DSO1(velAnaParam* pVelAnaParam, waveOpParams* pFDModelingParam, 
			  modelingFDgen_op* pModel, FWI_Param * pPar,bool bTaperEdge) : FWI_FD_DSO(pVelAnaParam, pFDModelingParam, pModel, pPar, bTaperEdge) {}
   virtual void calcBackProjData();
   //virtual float calcObjFunc();
public:

protected:
   //virtual void flipGradient(cubeData<float>& gradCube);
};


class FWI_FD_DSO2 : public FWI_FD_DSO {
public:
   FWI_FD_DSO2(velAnaParam* pVelAnaParam, waveOpParams* pFDModelingParam, 
			  modelingFDgen_op* pModel, FWI_Param * pPar,bool bTaperEdge) : FWI_FD_DSO(pVelAnaParam, pFDModelingParam, pModel, pPar, bTaperEdge) {}
   virtual void calcBackProjData();
public:

protected:
   //virtual void flipGradient(cubeData<float>& gradCube);
};

}
#endif
