#ifndef __RMOFINDER_H_INCL__
#define __RMOFINDER_H_INCL__

#include "stdafx.h"
#include "cubeData.hpp"
#include "my_types.h"
#include "decl_fwd.h"

using boost::shared_ptr;
using seplib::AGC_Param;

namespace Yang {
//Find precise moveout at single cand pt
class RMOfinder {
public:
  RMOfinder(const shared_ptr<const Param_RMO_Measurer>& pars):par_(pars) {}
  int RMOatPt(int* iCoords, const cubeDataF& img0, const cubeDataF& img_ax_t,const cubeDataF& img_ax_t_slice, const stdVecFloat& vecTan2Moveout,  //input
              std::valarray<int>& angle_axis_mask, std::valarray<float>& RMO_per_angle, float& ptWeight, float& rhoPick);  //output
  void inputGatherIs(const cubeDataF& img_ax_t);
  
public:
  cubeDataF matchFlter_,matchFltCCout_,maskCC_,mFltOutNMSup_;
  cubeDataF envelopeZ_ADCIG_,NMSupEnvelope_;
protected:
  shared_ptr<const Param_RMO_Measurer> par_;
  int ix_,iz_,iy_; //for current point
  cubeDataF semb_,envSemb_;
  cubeDataF gaussDeriv_;

private:
  void locateMoveoutUsingNbCorrelation(int igamma, int ilag, std::valarray<int>& angle_axis_mask, std::valarray<float>& RMO_per_angle, const stdVecFloat& estMoveoutPerAngle, const cubeDataF& img_axt_slice);
  void locateMoveoutUsingCC(int igamma, int ilag, std::valarray<int>& angle_axis_mask, std::valarray<float>& RMO_per_angle, const stdVecFloat& estMoveoutPerAngle, const cubeDataF& img_axt_slice);
  void locateMoveoutUsingEnvelopMaximum(int igamma, int ilag, std::valarray<int>& angle_axis_mask, std::valarray<float>& RMO_per_angle, const stdVecFloat& estMoveoutPerAngle, const cubeDataF& img_axt_slice);
  void locateMoveoutUsingDipTracking(int igamma, int ilag, std::valarray<int>& angle_axis_mask, std::valarray<float>& RMO_per_angle, const stdVecFloat& estMoveoutPerAngle, const cubeDataF& img_axt_slice);
  void locateMoveoutUsingSemblanceMaximum(int igamma, int ilag, valarray<int>& angle_axis_mask, valarray<float>& RMO_per_angle, const stdVecFloat& estMoveoutPerAngle, const cubeDataF& img_axt_slice,float& dJdrho,float& rhoPick) const;
};

} //end namespace
#endif // __ADCIG_RECON_H_INCL__

