#ifndef __WEMVA2_H_INCL__
#define __WEMVA2_H_INCL__

// TODO: your code here
#include "velAna.h"
#include "WEMVA.h"
#include "objFunc.h"

namespace Yang {
//angle domain implementation
class WEMVA_FD_DSO_ang : public WEMVA_FD {
public:
  WEMVA_FD_DSO_ang(velAnaParam* pVelAnaParam, 
      const shared_ptr<waveOps>& pModel, WEMVA_Param * pPar): 
  WEMVA_FD(pVelAnaParam,pModel,pPar) {}
   
   virtual void calcBackProjData();
   virtual float calcObjFunc();
protected:
	virtual void flipGradient(cubeData<float>& gradCube);
};
  
//Maximize stack power
class WEMVA_maxAngleStack: public WEMVA_FD{
public:
  WEMVA_maxAngleStack(velAnaParam* pVelAnaParam,
       const shared_ptr<waveOps>&  pModel, WEMVA_Param * pPar): 
  WEMVA_FD(pVelAnaParam,pModel,pPar) {}
  
  virtual void calcBackProjData();
  //calculate objective function, used in solver
  virtual float calcObjFunc();
};

//Use non-picking, correlation based objective function, use zero angle as reference.Based on angle moveout-parameters
class WEMVA_FD_angleMoveout : public WEMVA_FD_eventBased {
public:
   WEMVA_FD_angleMoveout(velAnaParam* pVelAnaParam,
			  const shared_ptr<waveOps>& pModel, WEMVA_Param * pPar): 
	 WEMVA_FD_eventBased(pVelAnaParam,pModel,pPar) {}
   
   virtual float  calcObjFunc();
   virtual void   calcBackProjData2d();
protected:
  void calcBackProjDataMultipleEvents(cubeDataF& imgAngleFlat);
};

//Use non-picking, correlation based objective function, use time shift images.
class WEMVA_FD_beamFocusTime : public WEMVA_FD_eventBased {
public:
   WEMVA_FD_beamFocusTime(velAnaParam* pVelAnaParam,
			  const shared_ptr<waveOps>& pModel, WEMVA_Param * pPar): 
	 WEMVA_FD_eventBased(pVelAnaParam,pModel,pPar) {m_bCalcAngleGather=false;}
   
   virtual float calcObjFunc();
   virtual void calcBackProjData2d();
protected:
};

}
