#ifndef __WEMVA_RMO_IMIT_H_INCL__
#define __WEMVA_RMO_IMIT_H_INCL__

// TODO: your code here
#include "decl_fwd.h"
#include "velAna.h"
#include "objFunc.h"
#include "WEMVA.h"

using boost::shared_ptr;
namespace Yang {

//The new WEMVA operator, use imitated tomography opeartor, use flat angle gathers + RMO info to synthesize the slowness gradient.
//Inherit the objFunc interface as well 
class WEMVA_RMO_Imit: public WEMVA_FD_eventBased {
private:
  shared_ptr<RMO_Measurer>  RMO_measure_;
  shared_ptr<ADCIG_Recon>   ADCIG_Recon_;
  bool bUpdateRMOneeded_;

protected:
  //an awful workout to avoid duplicate computations.
  virtual void onImageUpdated() {//if the migrated image is just updated
    WEMVA_FD::onImageUpdated();
    bUpdateRMOneeded_=true;
  }
  void  RMO_upToDate();
  float RMO_objFunc();
public:
  // Constructor
  WEMVA_RMO_Imit(velAnaParam* pVelAnaParam, const shared_ptr<waveOps>& pWave, WEMVA_Param* pWEMVApar, const shared_ptr<RMO_Measurer>& RMO_measure,const shared_ptr<ADCIG_Recon>& ADCIG_Recon);  
  // Destructor
  virtual ~WEMVA_RMO_Imit() {}
  
  //virtual void calcData();
  //calculate objective function, used in solver
  
  //The interfaces from the objFunc class
  virtual void  callBackAtIter(int iIter) {} //call back for iterative solver
  
  virtual float calcObjFunc();
private:
  virtual void flipGradient(cubeData<float>& gradCube);
  void calcSlowGradient(cubeData<float>& velGradCube);
  
  virtual void calcBackProjData2d();
  virtual void calcBackProjData3d();
};

} //end namespace

#endif // __WEMVA_H_INCL__

