#include "stdafxc.h"
#include <cutil.h>
#include <cuda.h>
#include "cudaErrors.cu.h"

#include "gpu_util.cu.h"
//all numbers are of element size.
void myCudaMemcpy2d(void* dst, int dpitch, const void* src, int spitch, int cpnz, int cpnx, enum cudaMemcpyKind kind,
                    int offz_dst, int offx_dst, int offz_src, int offx_src, int esize) {
  const char* pSrc;
  char *pDest;
  //sanitary check
  assert(offz_dst+cpnz <= dpitch);
  assert(offz_src+cpnz <= spitch);
  pSrc = (const char*)src + esize*(spitch*offx_src+offz_src);
  pDest= (char*)dst + esize*(dpitch*offx_dst+offz_dst);
  cuda_call(cudaMemcpy2D(pDest,dpitch*esize,pSrc,spitch*esize,
                         cpnz*esize,cpnx,kind));
  return;
}

