#include "stdafx.h"
#include "dmRsf.hpp"

#include "srcWav.h"
#include "velFD2d.h"
#include "point3d.hpp"

#include "modelingFD2d_op.h"
#include "modelingFDgpu.h"

#include "SR_manager.h"
#include "paddingFD.h"
#include "paddingFD_damping.h"
#include "boundaryFD.h"

#include "param_entry.h"
#include "myOMP.h"

#include "FWI_FD.h"
#include "FWI_FD_beamFocus.h"
#include "FWI_FD_DSO.h"
#include "stackTraceC.h"
#include "FWI_objFunc.h"

#include "commonOps.h"
#include "solverNonlinearSearch.h"

#include "sep_params.h"
//Read params
#include "nonLinSolver.param.h"
#include "velAna.param.h"
#include "wavePropagate.param.h"
//#include "../misc.h"

/**
 * For beam focusing, Wave Equation Tomography, Just do the 
 * non-linear line search, Transmission case
 */


using namespace Yang;
using namespace std;

   

int main (int argc, char *argv[])
{
  initCallStackTrace();
  
  //Read params, params need contain geometry info that is exact the same as the input data. In
  //synthetic this is easy to do.
  auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  
  //Create a WEMVA object
  //WEMVA_FD* Yang::create_WEMVA_obj(velAnaParam* pVApar, waveOpParams* pModelPar, waveOps* pModelingObj, WEMVA_Param* pWEMVApar, param_func* pars) {
  WEMVA_Param wemvaPar;
  WEMVA_FD_DSO_off * pWEMVAobj = new WEMVA_FD_DSO_off(NULL, NULL, NULL, &wemvaPar);
  //Read the image
  wemvaPar.Img0_hx.load("in",true);
  
  //calc obj
  float fObj = pWEMVAobj->calcObjFunc();
  prt("\n The obj func value is = %f \n", fObj);
  return 0;
}

