#include "stdafx.h"
#include "axis.h"
#include "dmRsf.hpp"
#include "dmRsfDump.h"
#include "sep_params.h"
#include "stackTraceC.h"
#include "commonOps.h"

///Read parameters
#include "dipEstimator.h"

/*
 * Input migrated offset gather(might be random subsampled,
 then compute the objective function and calculate the back projected data.
 */

//Reflection case
using boost::shared_ptr;
using namespace Yang;
using namespace std;
using namespace seplib;

/// Use sparse sampled ODCIG to reconstructed ADCIG
int main (int argc, char *argv[]) {
  initCallStackTrace();
  
  //Read params, params need contain geometry info that is exact the same as the input data. In
  //synthetic this is easy to do.
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  shared_ptr<cubeDataF> dat(new cubeDataF());
  
  dat->load("in");
  
  //Estimate the dip and measure the moveout
  shared_ptr<StructTensorParam> par_ST(new StructTensorParam("TT")); par_ST->readParam(pars);
  shared_ptr<dipEstimator> est(new dipEstimator(par_ST));
  est->inputImgIs(dat);
  
  const cubeDataF& dipAngle = est->dipAngleX_deg(); dipAngle.dump("out");
  est->dipEstMask().dump("dmsk"); est->linearityFactor().dump("dlin");
  return 0;
}

