#include "stdafx.h"
#include "axis.h"
#include "dmRsf.hpp"
#include "dmRsfDump.h"
#include "sep_params.h"
#include "stackTraceC.h"
#include "commonOps.h"

///Read parameters
#include "algo.h"
#include "cubeAlgo2.h"

/*
 * Input the cand pt coordinates, output the pt index corresponding to the closest pt in the cand pts set.
 */

using boost::shared_ptr;
using namespace Yang;
using namespace std;
using namespace seplib;

int main (int argc, char *argv[]) {
  initCallStackTrace();
  
  //Read params, params need contain geometry info that is exact the same as the input data. In
  //synthetic this is easy to do.
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  shared_ptr<cubeDataF> dat(new cubeDataF());
  dat->load("in"); const hypercube& shp = dat->domain();
  int ndim = shp.get_n(1);
  float fdef[3] = {0.0f,0.0f,0.0f}; int nRead;
  float* pCoords = pars->get_floats("coords",3,fdef,&nRead);
  PRVEC(pCoords,nRead);
  VERIFY(ndim <= 3);
  long n23 = shp.get_n23(); 
  PRV(n23); shp.info("shp");
  
  int i,j; float ftmp;
  stdVecFloat dists(n23);
  for (i=0; i<n23; i++) {
    float dist = 0.0f;
    for (j=0;j<ndim;j++) {
      ftmp = (*dat)[i*ndim+j] - pCoords[j];
      dist += SQ(ftmp);
    }
    dists[i] = dist;
  }
  //prtStdVec(dists);
  //now find the minimum
  int ptIndex = std::min_element(dists.begin(),dists.end()) - dists.begin();
  prt("closest pt Index is %d, and the distance is %f \n", ptIndex,sqrtf(dists[ptIndex]));
}

