#include "stdafx.h"
#include "axis.h"
#include "dmRsf.hpp"
#include "dmRsfDump.h"
#include "sep_params.h"
#include "stackTraceC.h"
#include "commonOps.h"

/*
 * Input vel model, generate very simple refl model, with flat reflector spaced at certain intervals.
 */

//Reflection case
using boost::shared_ptr;
using namespace Yang;
using namespace std;
using namespace seplib;

/// Use sparse sampled ODCIG to reconstructed ADCIG
int main (int argc, char *argv[]) {
  initCallStackTrace();
  
  //Read params, params need contain geometry info that is exact the same as the input data. In
  //synthetic this is easy to do.
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  shared_ptr<cubeDataF> vmod(new cubeDataF()),rout(new cubeDataF());
  
  vmod->load("in"); rout->alloc(vmod->domain());
  long n23 = vmod->domain().get_n23(); //cnt = 0;
  const vecAxis& axes = vmod->domain().get_axes();
  const axis& ax_z = axes[0];
  float dz = pars->get_float("deltaZ",10*ax_z.d);
  int ndz = int(dz/ax_z.d+0.5f); VERIFY(ndz>2);
  float scale=-1.0f;
  for (int iz=ndz+1; iz<ax_z.n-ndz/4; iz+=ndz) {
    scale *= -1.0f;
    for (int i=0; i<n23; i++) {
      (*rout)[IND2(iz,i,ax_z.n)] = 1.0f*scale;
    }
  }
  rout->dump("out");
}

