#include "stdafx.h"
#include "axis.h"
#include "dmRsf.hpp"
#include "dmRsfDump.h"

#include "sep_params.h"

#include "stackTraceC.h"
#include "commonOps.h"

#include "algo.h"
#include "cubeAlgo2.h"

/*
 * Input migrated offset gather(might be random subsampled,
 then compute the objective function and calculate the back projected data.
 */

//Reflection case
using boost::shared_ptr;
using namespace Yang;
using namespace std;
using namespace seplib;

/// Use sparse sampled ODCIG to reconstructed ADCIG
int main (int argc, char *argv[]) {
  initCallStackTrace();
  
  //Read params, params need contain geometry info that is exact the same as the input data. In
  //synthetic this is easy to do.
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  shared_ptr<cubeDataF> dat(new cubeDataF());
  
  dat->load("in");
  float qt = pars->get_float("qnt",0.99); //0.99 means to find the top 1% value point.
  
  cubeAbs(*dat,*dat);
  float fMaxVal = dat->maxvalAbs();
  long n123 = dat->domain().get_n123();
  float fQt = quantile((int)(n123*qt), dat->dataPtr(), n123);
  prt("MaxAbsVal is %e, qnt value is %e at qnt=%2.3f \n", fMaxVal,fQt,qt);
}

