#include <stdafx.h>
//build a two layer mode

#include <sep_params.h>

#include <cubeData.hpp>

using namespace Yang;

int ind2d(int nz, int iz,int ix)
{
    return ix*nz+iz;
}

void genmodel(int* pnz, int* pnx, float* model, float *pslope)
{
    int nz,nx;
    float vl,vh,slope;

    float t1;
    int i,j,ix;

    vl=2500; vh=3500;

    nz = *pnz;
    nx = *pnx;
    slope = *pslope;

    for (i=0;i<nx;i++){  
        for (j=0;j<nz;j++){
            t1= nz/nx*slope*(i-nx/2) + nz/2;
            if ( j >= t1)
                model[ind2d(nz,j,i)] = vh;
            else
                model[ind2d(nz,j,i)] = vl;
        }
    }
}


//Simple Vel Model
int main(int argc, char* argv[])
{
  //Read param
  sep_params pars(argc,argv);

  int n1,n2,n3;
   n1 = pars.get_int("n1");
   n2 = pars.get_int("n2");
   n3=1;
   float d1,d2;
   d1 = pars.get_float("d1");
   d2 = pars.get_float("d2");

   float slope = pars.get_float("slope",0.0);
   
   //PRV(n1) PRV(n2) PRV(n3)   
   cerr << n1 << n2 << n3 << endl;

   cubeData<float> mod2d;
   vector<axis> axes;
   axes.push_back(axis(n1,0.0f,d1,"z(m)"));
   axes.push_back(axis(n2,0.0f,d2,"x(m)"));

   hypercube shape;
   shape.set_axes(axes);
   //shape.info("shape info");

   mod2d.init(&shape); //Get allocated when getDomain

   cerr << "mark1" << endl;
   //Get the memory space
   float* p = mod2d.getDataPtr();
   
   genmodel(&n1,&n2,p,&slope);
   mod2d.dump("out");
}
