#include "stdafx.h"
#include "dmRsf.hpp"
#include "cubeData.hpp"
#include "sep_params.h"
#include "misc.h"
#include "dmHeaderReader.h"
#include "waveOpMPI.h"


/**
 * break the file to individual ones for each slave process.
 */

//Reflection case
using namespace Yang;
using namespace std;

using boost::shared_ptr;
//Doing beam wave-equation tomography for reflection case.

//Do born modeling
int main (int argc, char *argv[])
{
  shared_ptr<sep_params> pars(new sep_params(argc,argv));
  //get the filename, 
  //The outfile will be in the same folder as in File
  string fnIn   = pars->get_string("inFile");
  string datapath = pars->get_string("datapath","");
  int iAxis = pars->get_int("axis"); //divide through with axis
  int np    = pars->get_int("np");
  VERIFY(np>1);
  np -= 1; //number of slaves.
  
  //Read in the header info.
  sepHeaderReader hReader(fnIn, dm::IN, "", true);
  hypercube shp;
  hReader.getShape(shp);
  
  shp.info("shp");
  const axis& ax = shp.get_axis(iAxis);
  int n = ax.n;
  
  branchFileName bf(fnIn);
  int npp,fpp;
  char szCmd[4096];
  
  for (int ir=1; ir<=np; ir++) {
    npp = int((n-ir)/np)+1; //the number of shots for this process, it handles shots ir,ir+np,ir+2*np,..., till shots n
    fpp = ir-1;
    sprintf(szCmd,"Window3d <%s f%d=%d j%d=%d n%d=%d squeeze=n >%s", fnIn.c_str(), iAxis,fpp, iAxis,np, iAxis,npp, bf.fn_at(ir).c_str());
    if (!datapath.empty()) {
      char sz[1024];
      sprintf(sz," datapath=%s ", datapath.c_str());
      strcat(szCmd,sz);
    }
    PRV(szCmd);
    VERIFY(system(szCmd)==0);
  }
  return 0;
}

