#include "stdafx.h"
#include "sep_params.h"

#include "dmRsf.hpp"
#include "dmRsfDump.h"

#include "cubeData.hpp"
#include "dampingFunc.h"
#include "stackTraceC.h"

using namespace Yang;

int main(int argc, char* argv[])
{
	//signal(SIGSEGV,handler);
    //signal(SIGABRT,handler);
	int i;
	sep_params* pars = new sep_params(argc,argv);
	
	cubeData<float> inCube("in",dm::IN,"");
	bool bRemoveDummyAxis=true;
	inCube.init(NULL,bRemoveDummyAxis);

	cubeData<float> outCube("out",dm::OUT,"");
	//cubeData<float> outCube;
	outCube.init(&(inCube.domain()));
	
	int tapLen = pars->get_int("taperLength");
	PRV(tapLen);
	cosDampingFunc dampFunc;
	stdVecFloat dampCoef;
	dampFunc.getCoefEx(dampCoef,tapLen,1.0);
	PRVEC(dampCoef,tapLen);
	LOG(Create dampFunc);
	inCube.copyTo(outCube);
	
	int nTrc = inCube.domain().get_n23();
	int nt = inCube.domain().get_n(1);
	const float *pIn;
	float *pOut;
	LOG(enter the nTrc loop);
	//PRVEC((inCube.dataPtr()),50)
	PRV(inCube.RMS());
	for (i=0;i<nTrc;i++) {
	   pIn  = inCube.dataPtr()  + i*nt;
	   pOut = outCube.dataPtr() + i*nt;
	   for (int j=nt-1; j>=nt-tapLen ; j--) {
		  *(pOut+j) = *(pIn+j) * dampCoef[j-(nt-tapLen)];
	   }
	}
	LOG(finish the loop)
	inCube.unInit(); 
	outCube.unInit();
	//SAFE_DELETE(pars);
	return 1;
}
