#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "misc.h"
#include "cubeAlgo.h"

using namespace Yang;
using namespace std;

//Demonstrate the input gather and the RMO modulated gather.

int main( int argc, char** argv){
  
  //Read params
  boost::shared_ptr<sep_params> pars(new sep_params(argc,argv));
  cubeData<float> input,output;
  input.load("in",2); //the one adcig
  
  axis ax_p = input.domain().get_axis(2);
  int np=ax_p.n;  hypercube shpn(ax_p); cubeDataF slope(shpn);
  for (int ip=0;ip<np; ip++) {
    float f_rad = atan2f(ax_p.get_coord(ip),1.0f);
    slope[ip] = SQ(tanf(f_rad));
  }
  float favg = slope.sum()/float(np);
  slope.add(-favg*0.6f);
  
  output.alloc(input.domain());
  //use it to multiply the adcig
  scaleSlice(output,input,slope);
  slope.dump("dump1");
  output.dump("out");
}

