#include "stdafx.h"
#include "cubeData.hpp"
#include "velFD2d.h"
#include "velAna.h"

// TODO: your implementation here
using namespace Yang;


void velAna_FD::loadDataObs() {
   m_pVelAnaParam-> dObsCube.init( &(m_pVelAnaParam->pDataObs->domain()) );
   m_pVelAnaParam-> pDataObs->seq_grabAll( & m_pVelAnaParam->dObsCube);
}

void velAna_FD::setVelocity(const cubeDataF* pVelCube) {
   waveOp_->vmodIs(*pVelCube);
}

void velAna_FD::setMoveoutDeriv(cubeData<float>& cube, tagMoveOutType tp)
{
  axis ax= cube.domain().get_axis(1);
  VERIFY(cube.domain().get_ndim()==1);
  int n = ax.n;
  float o = ax.o;
  float d = ax.d;
  float x;
  
  //it has to be radian, not degree
  if (tp == tangentSquare) {
    float t1 = fabs(o), t2 = fabs(o+(n-1)*d);
    VERIFY( t1 < PI/2);
    VERIFY( t2 < PI/2);
    VERIFY( t1>(PI/180.0f) || t2>(PI/180.0f) ); //should be at least bigger than 1deg.
  }
  for(int i=0;i<n;i++)
  {
	  x = o + i*d;
	  if (tp == Quadratic) 
		 cube[i] = x*x;
	  else if (tp == Linear)
		 cube[i] = x;
	  else if (tp == tangentSquare)
     cube[i] = SQ(tanf(x));
    else if (tp == constant)
     cube[i] = 1.0f; 
    else {
       prt("\nWrong MoveoutType in beamFocus func");
       abort();
    }
  }
  return;
}

