#ifndef WAVELET_F_H
#define WAVELET_F_H 1

extern "C" {
  void set_wavelet_direction_f03(int dir);
  void init_wavelet_transform_f03(float* smoother_c,float* roughner_c,int nsm,int nrgh,int n1,int n2,int n3,int n4,int lev1,int lev2,int lev3,int lev4);
  int  wavelet_transform_op_f03(int adj,int add,float* model,float *data);
}

inline int bool2int(bool b) {
  return b?1:0;
}

inline void setWaveletDirection(bool dir) {
  set_wavelet_direction_f03(bool2int(dir));
}
inline int wavelet_transform_op(bool adj,bool add,float* model,float *data){
  return wavelet_transform_op_f03(bool2int(adj),bool2int(add),model,data);
}

//wrap an operator over wavelet_transform
#include "op.h"

namespace Yang {
class opWaveletComp:public op {
public:
  virtual ~opWaveletComp() {}
  void set_wavelet_direction(bool bFwd) {
    setWaveletDirection(bFwd);
  }
  void init(float* smoother_c,float* roughner_c,int nsm,int nrgh,int n1,int n2,int n3, int n4, int lev1,int lev2,int lev3,int lev4);
  virtual void oper(cubeData<float>& mod, cubeData<float>& dat, bool bAdj, bool bAdd);
  
};

} //end namespace Yang

#endif
